Subject: RE: [mobile-ip] RFC3012bis - Comments from ADs (Protocol related) (ISSUE No. 14)

From: "Jayshree Bharatia" <[email-masked]>
Date: Tue, 12 Nov 2002 17:07:24 -0600

> Hello,
> 
> I have the following text as a proposed change for  RFC3012bis-issue 14
> (which is almost same as Ahmad's proposed text):
> 
> Existing Text
> (section 12)
> Whenever a Foreign Agent updates a field of the Registration Reply (as
> suggested in section 3.2), it invalidates the authentication data supplied
> by the Home Agent in the Mobile-Home Authentication extension to the
> Registration Reply.  Thus, this opens up a security exposure whereby a
> node might try to supply a bogus Registration Reply to a mobile node that
> causes the mobile node to act as if its Registration Reply were rejected.
> This might happen when, in fact, a Registration Reply showing acceptance
> of the registration might soon be received by the mobile node
> 
> New Text:
> (section 12)
> The Foreign Agent inserts the MN-FA Challenge extension which is after the
> Mobile-Home authentication extension (section 3.3). This does not
> invalidate the authentication data supplied by the Home Agent in the
> Mobile-Home Authentication extension to the Registration Reply. However,
> if there is no security association between the Mobile node and the
> Foreign Agent, a malicious node might try to supply a bogus Registration
> Reply to the Mobile Node. This causes the mobile node to act as if its
> Registration Reply was rejected.  This might happen when, in fact, a
> Registration Reply showing acceptance of the registration might soon be
> received by the mobile node. 
> 
> Please let me know your comments .
> 
> Thanks,
> Jayshree
> 
> 
>

---

From: "Jayshree Bharatia" <[email-masked]>
Date: Tue, 12 Nov 2002 17:07:24 -0600

---

From: "Fredrik Johansson" <[email-masked]>
Date: Wed, 13 Nov 2002 16:33:04 +0100

RE: [mobile-ip] RFC3012bis - Comments from ADs (Protocol related) (ISSUE No.
14)Ahmad,

I guess it's hard to protect a mobile node from such an attack unless
authentication is used between the mn and fa. If authentication is used the
mn will discard the bogus reply and still wait for the correct reply.

/Fredrik
  -----Original Message-----
  From: [email-masked]
[mailto:[email-masked]]On Behalf Of Ahmad Muhanna
  Sent: den 27 september 2002 16:27
  To: 'Fredrik Johansson'; [email-masked];
[email-masked]
  Cc: 'Charlie Perkins'
  Subject: RE: [mobile-ip] RFC3012bis - Comments from ADs (Protocol related)
(ISSUE No. 14)

  Hi Fredrick,
  Please see comments inline.
  Regards;
  Ahmad Muhanna

  > See comments inline
  > /fredrik
  >
  > > please see comments inline.
  > > Regards;
  > > Ahmad Muhanna

  > >
  > > 14. Section 12
  > >    Whenever a Foreign Agent updates a field of the
  > Registration Reply
  > >    (as suggested in section 3.2), it invalidates the authentication
  > >   data supplied by the Home Agent in the Mobile-Home Authentication
  > >   extension to the Registration Reply.  Thus, this opens up
  > a security
  > >   exposure whereby a node might try to supply a bogus Registration
  > >   Reply to a mobile node that causes the mobile node to act
  > as if its
  > >   Registration Reply were rejected.  This might happen
  > when, in fact, a
  > >   Registration Reply showing acceptance of the registration
  > might soon
  > >   be received by the mobile node.
  > >   The section reference should be 3.3.
  > > <<Ahmad>> agreed.
  > >   More importantly, is there no way to ameliorate this?
  > >   It seems like a serious technical definiciency.
  > > <<Ahmad>>
  > > I think this paragraph needs to be modified. It is somewhat
  > confusing
  > > and
  > I am not sure
  > > if it is accurate.
  > > In section 3.3., the FA inserts the MN-FA Challenge
  > extension which is
  > after the MN-HA
  > > authentication extension. This does not invalidate the
  > authentication
  > > data
  > supplied by
  > > the Home Agent in the Mobile-Home Authentication extension in the
  > Registration Reply.
  > > On the other hand, If a Registration Reply with error code is
  > > generated by
  > the Foreign
  > > Agent, Only this scenario is vulnerable to bogus attack. More
  > > explanation
  > in the following example:
  > > 1. A MN1 sends a RRQ1 message to FA1 with challenge FAC1.
  > > 2. FA1 process the RRQ1 and relay the RRQ1 to the specified HA1. 3.
  > > FA1 starts a timer to receive a RRP1 message from HA1.
  > >    3.1. Now: there is a possibility of a malicious node CN2
  > which has
  > captured
  > >         the information from the RRQ to build a RRPx
  > message and send
  > > it
  > to
  > >         MN1 with an FA generated error code "ONLY FA error code may
  > > work
  > here"
  > >    3.2. If CN2 is able to build and send this RRPx message
  > before the
  > > MN1
  > receives
  > >         a RRP1 from FA1, there a possibility that MN1 will think its
  > Registration
  > >         Request has been denied by FA1. Although, MN1 will receive
  > > RRP1
  > later on, but
  > >         it is too, late.
  > > 4. This only happens if there is no Security Association
  > between MN1
  > > and
  > FA1.
  > > With this limitation in mind, I suggest this paragraph be
  > replaced by
  > > the
  > following:
  > > "
  > >    Whenever a Foreign Agent updates a field of the
  > Registration Reply
  > >    (as suggested in section 3.3), it does not invalidate the
  > authentication
  > >    data supplied by the Home Agent in the Mobile-Home Authentication
  > >    extension to the Registration Reply.  However, if there
  > is no security
  > >    association between the mobile node and the Foreign
  > Agent, a malicious
  > >    node might try to supply a bogus Registration Reply to a
  > mobile node
  > >    that causes the mobile node to act as if its
  > Registration Reply has
  > been
  > >    rejected by the Foreign Agent. This might happen when, in fact, a
  > Registration
  > >    Reply showing acceptance of the registration might soon
  > be received by
  > >    the mobile node.
  > > "
  > > The original paragraph itself hint to a possible solution:
  > Ether the
  > > Mobile Node wait for a RRP message with the same ID as its RRQ
  > message
  >
  > It allways have to do this, at least the low-order 32 bits of
  > the identification field From 3344 section 3.6.2.1
  >
  > "In addition, the low-order 32 bits of the Identification field in the
  >    Registration Reply MUST be compared to the low-order 32 bits of the
  >    Identification field in the most recent Registration
  > Request sent to
  >    the replying agent.  If they do not match, the Reply MUST
  > be silently
  >    discarded."
  >

  Well, If the Mobile Node already received a RRPx message from the
attacker,
  I assume that the attacker used the correct ID in RRPx. This means that
the
  Mobile Node already received a RRP message with a matching ID for its RRQ1
message.

  Usually, the Mobile Node will react in response to the attacker RRPx.
  Either build a new RRQ message (RRQ2) and send it again and now the MN
  tracks the ID of RRP2 not RRP1. In other words, if the Mobile Node
  receives RRP1, it will discard it.

  However, if MN waits "?? How long??" after receiving a RRP message with
error code from the
  FA to check if another RRP with the same ID is coming from the HA, it
probably counter
  attack this scenario.

  Also, I am not saying that this is the best solution either.

  > But this doesn't prevent the attack you mention above.
  > /Fredrik
  >
  > > with a code generated by its Home Agent, or reissue a new
  > RRQ message.
  > > Regards, Ahmad
  >
  >

---

From: "Ahmad Muhanna" <[email-masked]>
Date: Wed, 13 Nov 2002 09:57:16 -0600

Fredrick,

I do not disagree with your statement.
I guess this is the limitation of RFC3012 & RFC3012-bis and the existing
text
my comment and (as later introduced by Jayshree) well highlight this
limitation 
under the Security Considerations section.

Regards; 
Ahmad

-----Original Message-----
From: Fredrik Johansson [mailto:[email-masked]] 
Sent: Wednesday, November 13, 2002 9:33 AM
To: Muhanna, Ahmad [RICH2:2Q20:EXCH]; [email-masked];

Ahmad,

/Fredrik
-----Original Message-----

Hi Fredrick, 
>    the replying agent.  If they do not match, the Reply MUST 
Well, If the Mobile Node already received a RRPx message from the attacker, 
I assume that the attacker used the correct ID in RRPx. This means that the

---

From: "Mohan Parthasarathy" <[email-masked]>
Date: Wed, 13 Nov 2002 09:58:26 -0800

Can someone explain as to why this attack is specific to 3012 ? If there
is no
MN-FA auth, even without extensions defined in 3012, today FA can reject
registration requests with "FA error code". Is that not possible ?
 
Going by the description given below, MN-FA challenge extension comes
after MN-HA auth. Wouldn't the MN-HA auth still protect all of the
contents
till MN-HA authenticator ? In that case, the MN can check the validity
of that
part and see whether it is bogus or not. Why doesn't that work ?
 
thanks
-mohan

	-----Original Message-----
	From: Ahmad Muhanna [mailto:[email-masked]] 
	Sent: Wednesday, November 13, 2002 7:57 AM
	To: 'Fredrik Johansson'; [email-masked];
[email-masked]
	Cc: 'Charlie Perkins'; Jayshree Bharatia
	Subject: RE: [mobile-ip] RFC3012bis - Comments from ADs
(Protocol related) (ISSUE No. 14)

	Fredrick, 

	I do not disagree with your statement. 
	I guess this is the limitation of RFC3012 & RFC3012-bis and the
existing text 
	my comment and (as later introduced by Jayshree) well highlight
this limitation 
	under the Security Considerations section. 

	Regards; 
	Ahmad 

	-----Original Message----- 
	From: Fredrik Johansson
[mailto:[email-masked]] 
	Sent: Wednesday, November 13, 2002 9:33 AM 
	To: Muhanna, Ahmad [RICH2:2Q20:EXCH]; [email-masked];
[email-masked] 
	Cc: 'Charlie Perkins' 
	Subject: RE: [mobile-ip] RFC3012bis - Comments from ADs
(Protocol related) (ISSUE No. 14) 

	Ahmad, 

	I guess it's hard to protect a mobile node from such an attack
unless authentication is used between the mn and fa. If authentication
is used the mn will discard the bogus reply and still wait for the
correct reply.

	/Fredrik 
	-----Original Message----- 
	From: [email-masked]
[mailto:[email-masked]]On Behalf Of Ahmad Muhanna 
	Sent: den 27 september 2002 16:27 
	To: 'Fredrik Johansson'; [email-masked];
[email-masked] 
	Cc: 'Charlie Perkins' 
	Subject: RE: [mobile-ip] RFC3012bis - Comments from ADs
(Protocol related) (ISSUE No. 14) 

	Hi Fredrick, 

	>    the replying agent.  If they do not match, the Reply MUST 
	Well, If the Mobile Node already received a RRPx message from
the attacker, 
	I assume that the attacker used the correct ID in RRPx. This
means that the 
	Mobile Node already received a RRP message with a matching ID
for its RRQ1 message. 
	Usually, the Mobile Node will react in response to the attacker
RRPx. 
	Either build a new RRQ message (RRQ2) and send it again and now
the MN 
	tracks the ID of RRP2 not RRP1. In other words, if the Mobile
Node 
	receives RRP1, it will discard it. 
	However, if MN waits "?? How long??" after receiving a RRP
message with error code from the 
	FA to check if another RRP with the same ID is coming from the
HA, it probably counter 
	attack this scenario. 
	Also, I am not saying that this is the best solution either.

---

From: "Jayshree Bharatia" <[email-masked]>
Date: Wed, 13 Nov 2002 13:35:32 -0600

Hello Mohan,
 
The original issue is related to the following text in section 12 of
RFC3012bis.
"Whenever a Foreign Agent updates a field of the Registration Reply (as
suggested in section 3.2), it invalidates the authentication data supplied
by the Home Agent in the Mobile-Home Authentication extension to the
Registration Reply"
 
This text is misleading. As you have mentioned in your email, the Challenge
extension is added after the Mobile-Home Authentication extension. Hence
updating the challenge at the FA doesn't invalidate the data supplied by the
Home Agent in the Mobile-Home Authentication extension to the Registration
Reply. 
 
A malicious node might try to supply a bogus Registration Reply to the
Mobile Node if there is no SA between the Mobile Node and the Foreign Agent.
I also agree that this problem is not introduced by RFC3012bis.
 
Please refer to my earlier email for the proposed text for section 12.
 
Thanks,
Jayshree

-----Original Message-----
From: Mohan Parthasarathy [mailto:[email-masked]]
Sent: Wednesday, November 13, 2002 11:58 AM
To: Muhanna, Ahmad [RICH2:2Q20:EXCH]; Fredrik Johansson;
[email-masked]; [email-masked]
Cc: Charlie Perkins; Bharatia, Jayshree [RICH1:2H13:EXCH]
Subject: RE: [mobile-ip] RFC3012bis - Comments from ADs (Protocol related)
(ISSUE No. 14)

Can someone explain as to why this attack is specific to 3012 ? If there is
no
MN-FA auth, even without extensions defined in 3012, today FA can reject
registration requests with "FA error code". Is that not possible ?
 
Going by the description given below, MN-FA challenge extension comes
after MN-HA auth. Wouldn't the MN-HA auth still protect all of the contents
till MN-HA authenticator ? In that case, the MN can check the validity of
that
part and see whether it is bogus or not. Why doesn't that work ?
 
thanks
-mohan

-----Original Message-----
From: Ahmad Muhanna [mailto:[email-masked]] 
Sent: Wednesday, November 13, 2002 7:57 AM
To: 'Fredrik Johansson'; [email-masked];

Fredrick, 

Regards; 
Ahmad 

-----Original Message----- 
From: Fredrik Johansson [ mailto:[email-masked]
<mailto:[email-masked]> ] 
Sent: Wednesday, November 13, 2002 9:33 AM 
To: Muhanna, Ahmad [RICH2:2Q20:EXCH]; [email-masked];
[email-masked] 
Cc: 'Charlie Perkins' 
Subject: RE: [mobile-ip] RFC3012bis - Comments from ADs (Protocol related)
(ISSUE No. 14) 

Ahmad, 

/Fredrik 
-----Original Message----- 
From: [email-masked] [
mailto:[email-masked]
<mailto:[email-masked]> ]On Behalf Of Ahmad Muhanna 
Sent: den 27 september 2002 16:27 
To: 'Fredrik Johansson'; [email-masked];
[email-masked] 
Cc: 'Charlie Perkins' 
Subject: RE: [mobile-ip] RFC3012bis - Comments from ADs (Protocol related)
(ISSUE No. 14) 

Hi Fredrick,

---

From: "Mohan Parthasarathy" <[email-masked]>
Date: Wed, 13 Nov 2002 12:02:32 -0800

Jayahree,

comments inline.

The original issue is related to the following text in section 12 of
RFC3012bis.
"Whenever a Foreign Agent updates a field of the Registration Reply (as
suggested in section 3.2), it invalidates the authentication data
supplied by the Home Agent in the Mobile-Home Authentication extension
to the Registration Reply"

This text is misleading. As you have mentioned in your email, the
Challenge extension is added after the Mobile-Home Authentication
extension. Hence updating the challenge at the FA doesn't invalidate the
data supplied by the Home Agent in the Mobile-Home Authentication
extension to the Registration Reply. 

Mohan>> Correct. clarifying should fix the problem in the document.

A malicious node might try to supply a bogus Registration Reply to the
Mobile Node if there is no SA between the Mobile Node and the Foreign
Agent. I also agree that this problem is not introduced by RFC3012bis.

Mohan>> Why is this related to the above ?  The proposed text by both
you and Ahmad had this also :

	However, if there is no security association between the Mobile
node and the Foreign Agent,
      a malicious node might try to supply a bogus Registration Reply to
the Mobile Node. This causes
      the mobile node to act as if its Registration Reply was rejected.
This might happen when, in fact,
      a Registration Reply showing acceptance of the registration might
soon be received by the mobile node. 

This is not related to the specific issue raised and don't know why it
belongs here. It would be enough to
clarify that by adding the MN-FA extension (which is what this document
is about), that the MN-HA does not get affected. The above is a general
threat and I don't know why it is related to this.  

-mohan

Thanks,
Jayshree
-----Original Message-----
From: Mohan Parthasarathy [mailto:[email-masked]]
Sent: Wednesday, November 13, 2002 11:58 AM
To: Muhanna, Ahmad [RICH2:2Q20:EXCH]; Fredrik Johansson;
[email-masked]; [email-masked]
Cc: Charlie Perkins; Bharatia, Jayshree [RICH1:2H13:EXCH]
Subject: RE: [mobile-ip] RFC3012bis - Comments from ADs (Protocol
related) (ISSUE No. 14)

thanks
-mohan

-----Original Message-----
From: Ahmad Muhanna [mailto:[email-masked]] 
Sent: Wednesday, November 13, 2002 7:57 AM
To: 'Fredrik Johansson'; [email-masked];
[email-masked]
Cc: 'Charlie Perkins'; Jayshree Bharatia
Subject: RE: [mobile-ip] RFC3012bis - Comments from ADs (Protocol
related) (ISSUE No. 14)

Fredrick, 
-----Original Message----- 
From: Fredrik Johansson [mailto:[email-masked]] 
Sent: Wednesday, November 13, 2002 9:33 AM 
To: Muhanna, Ahmad [RICH2:2Q20:EXCH]; [email-masked];
[email-masked] 
Cc: 'Charlie Perkins' 
Subject: RE: [mobile-ip] RFC3012bis - Comments from ADs (Protocol
related) (ISSUE No. 14) 

Ahmad, 
I guess it's hard to protect a mobile node from such an attack unless
authentication is used between the mn and fa. If authentication is used
the mn will discard the bogus reply and still wait for the correct
reply.
/Fredrik 
-----Original Message----- 
Subject: RE: [mobile-ip] RFC3012bis - Comments from ADs (Protocol
related) (ISSUE No. 14) 

Hi Fredrick, 

Mobile Node already received a RRP message with a matching ID for its
RRQ1 message.

---

From: "Jayshree Bharatia" <[email-masked]>
Date: Wed, 13 Nov 2002 15:45:04 -0600

Hello Mohan,

If it is agreeable to everyone, I will remove the second paragraph of
section 12 ("Whenever a foreign Agent updates a field of the Registration
Reply.....a Registration Reply showing acceptance of the registration might
soon be received by the mobile node".

Any Comment?

Thanks,
Jayshree  

-----Original Message-----
From: Mohan Parthasarathy [mailto:[email-masked]]
Sent: Wednesday, November 13, 2002 2:03 PM
To: Bharatia, Jayshree [RICH1:2H13:EXCH]; Muhanna, Ahmad
[RICH2:2Q20:EXCH]; Fredrik Johansson; [email-masked];
[email-masked]
Cc: Charlie Perkins
Subject: RE: [mobile-ip] RFC3012bis - Comments from ADs (Protocol
related) (ISSUE No. 14)

Jayahree,

comments inline.

-mohan

Thanks,
Jayshree
-----Original Message-----
From: Mohan Parthasarathy [mailto:[email-masked]]
Sent: Wednesday, November 13, 2002 11:58 AM
To: Muhanna, Ahmad [RICH2:2Q20:EXCH]; Fredrik Johansson;

thanks
-mohan

-----Original Message-----
From: Ahmad Muhanna [mailto:[email-masked]] 
Sent: Wednesday, November 13, 2002 7:57 AM
To: 'Fredrik Johansson'; [email-masked];

Fredrick, 
-----Original Message----- 
From: Fredrik Johansson [mailto:[email-masked]] 
Sent: Wednesday, November 13, 2002 9:33 AM 
To: Muhanna, Ahmad [RICH2:2Q20:EXCH]; [email-masked];

Ahmad, 
-----Original Message----- 

Hi Fredrick,